import processing.net.*;
Server myServer = new Server(this, 54321);

String agent1ip = null;
String agent2ip = null;
// グー0, チョキ1, パー2とする
int agent1Hand = -1;
int agent2Hand = -1;
int agent1Point = 0;
int agent2Point = 0;
Client agent1 = null;
Client agent2 = null;
// wait time
int waitTime = 500;

void setup()
{
  size(1000, 200);
}

void draw()
{
  checkClients();
  jankenJudge();
  fill(255, 0, 0);
  rect(0, 0, agent1Point, 100);
  fill(0, 0, 255);
  rect(0, 100, agent2Point, 100);
}

void checkClients()
{
  Client nextClient = myServer.available();
  while (nextClient != null) {
    String recvStr = nextClient.readString();
    println(nextClient.ip(), recvStr);
    if ( recvStr.equals("JOIN") ) {
      // JOINって送ってきたやつを登録する
      // とりあえず2名限定にしている
      println(nextClient.ip());
      if (agent1ip == null ) {
        agent1ip = nextClient.ip();
        agent1 = nextClient;
        nextClient.write("ID1");
      } else {
        nextClient.write("ID2");
        agent2 = nextClient;
        agent2ip = nextClient.ip();
        if (agent1 != null && agent2 != null) {
          delay(waitTime);
          myServer.write("Next");
          // 下記でもOK
          // agent1.write("Next");
          // agent2.write("Next");
        }
      }
    } else if ( recvStr.equals("G") ) {
      // グーだった！
      if ( agent1ip.equals( nextClient.ip() ) ) {
        // agent1なら
        agent1Hand = 0;
      } else if ( agent2ip.equals( nextClient.ip() ) ) {        
        // agent2なら
        agent2Hand = 0;
      }
    } else if ( recvStr.equals("C") ) {
      // チョキだった！
      if ( agent1ip.equals( nextClient.ip() ) ) {
        // agent1なら
        agent1Hand = 1;
      } else if ( agent2ip.equals( nextClient.ip() ) ) {        
        // agent2なら
        agent2Hand = 1;
      }
    } else if ( recvStr.equals("P") ) {
      // パーだった！
      if ( agent1ip.equals( nextClient.ip() ) ) {
        // agent1なら
        agent1Hand = 2;
      } else if ( agent2ip.equals( nextClient.ip() ) ) {        
        // agent2なら
        agent2Hand = 2;
      }
    }
    nextClient = myServer.available();
  }
}

void jankenJudge()
{
  int[] pointJanken = {3, 5, 6};
  if (agent1Hand >= 0 && agent2Hand >= 0) {
    if (agent1Hand == agent2Hand) { // 引き分け
      agent1.write("Draw");
      agent2.write("Draw");
    } else if ((agent1Hand+1)%3==agent2Hand) { // a1の勝ち
      agent1Point += pointJanken[agent1Hand];
      agent1.write("Win");
      agent2.write("Lose");
    } else { // a2の勝ち
      agent2Point += pointJanken[agent2Hand];
      agent1.write("Lose");
      agent2.write("Win");
    }
    agent1Hand = -1;
    agent2Hand = -1;

    println(agent1Point, agent2Point);
    delay(waitTime);
    if (agent1Point>=1000 || agent2Point >=1000)
    {
      if (agent1Point > agent2Point) {
        agent1.write("Winner");
        agent2.write("Loser");
      } else {
        agent1.write("Loser");
        agent2.write("Winner");
      }
    } else {
      agent1.write("Next");
      agent2.write("Next");
    }
  }
}
